//+------------------------------------------------------------------+
//|                                                   MAofRSI_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers   3
#property indicator_color1    LightBlue
#property indicator_width1    2 
#property indicator_color2    Tomato
#property indicator_width2    1 
#property indicator_color3    Lime
#property indicator_width3    1 

#property indicator_level1    25
#property indicator_level2    50
#property indicator_level3    75

//---- input parameters
extern int       Price        =  0;
extern int       RSILength    = 45; 
extern int       FastMA       =  2;
extern int       FastMAMode   =  0;
extern int       SlowMA       =  3;
extern int       SlowMAMode   =  1;
//---- buffers
double RSI[];
double MAfast[];
double MAslow[];
double Bulls[];
double Bears[];
double AvgBulls[];
double AvgBears[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,RSI);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MAfast);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,MAslow);
   SetIndexBuffer(3,Bulls);
   SetIndexBuffer(4,Bears);
   SetIndexBuffer(5,AvgBulls);
   SetIndexBuffer(6,AvgBears);
//---- name for DataWindow and indicator subwindow label
   string short_name="MAofRSI("+RSILength+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"RSI");
   SetIndexLabel(1,"RSIfast");
   SetIndexLabel(2,"RSIslow");
//----
   SetIndexDrawBegin(0,2*RSILength-1);
     
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int      shift, limit, counted_bars=IndicatorCounted();
   double   Price1, Price2;
//---- 
   if ( counted_bars < 0 ) return(-1);
   if ( counted_bars ==0 ) limit=Bars-1;
   
   if ( counted_bars < 1 ) 
   for(int i=1;i<2*RSILength-1;i++) 
   RSI[Bars-i]=0;    
      
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;
   
   for( shift=limit; shift>=0; shift--)
   {
   Price1 = iMA(NULL,0,1,0,0,Price,shift);
   Price2 = iMA(NULL,0,1,0,0,Price,shift+1); 
      
   Bulls[shift] = 0.5*(MathAbs(Price1-Price2)+(Price1-Price2));
   Bears[shift] = 0.5*(MathAbs(Price1-Price2)-(Price1-Price2));
   }
   
   for( shift=limit; shift>=0; shift--)
   {  
   AvgBulls[shift] = iMAOnArray(Bulls,0,2*RSILength-1,0,MODE_EMA,shift);
   AvgBears[shift] = iMAOnArray(Bears,0,2*RSILength-1,0,MODE_EMA,shift);
   
   if ((AvgBulls[shift]+AvgBears[shift])!=0) RSI[shift] = 100*AvgBulls[shift]/
   (AvgBulls[shift]+AvgBears[shift]);   
   }
   
   for( shift=limit; shift>=0; shift--)
   {  
   if(FastMA>0) MAfast[shift] = iMAOnArray(RSI,0,FastMA,0,FastMAMode,shift);
   if(SlowMA>0) MAslow[shift] = iMAOnArray(RSI,0,SlowMA,0,SlowMAMode,shift);
   }
//----
   return(0);
}
//+------------------------------------------------------------------+